using System;
using System.Collections.Generic;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainForm()

        /// <summary>
        /// 
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.pictureBox.Resize += pictureBox_Resize;
            this.pictureBox.Paint  += pictureBox_Paint;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region ó ڽ ũ  óϱ - pictureBox_Resize(sender, e)

        /// <summary>
        /// ó ڽ ũ  óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pictureBox_Resize(object sender, EventArgs e)
        {
            this.pictureBox.Refresh();
        }

        #endregion
        #region ó ڽ Ʈ óϱ - pictureBox_Paint(sender, e)

        /// <summary>
        /// ó ڽ Ʈ óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void pictureBox_Paint(object sender, PaintEventArgs e)
        {
            using(Font font = new Font("ڵ", 40, FontStyle.Bold))
            {
                Color topBackgroundColor    = Color.RoyalBlue;
                Color topForegroundColor    = Color.White;
                Color bottomBackgroundColor = Color.White;
                Color bottomForegroundColor = Color.RoyalBlue;

                SolidBrush topBackgroundBrush    = new SolidBrush(topBackgroundColor   );
                SolidBrush topForegroundBrush    = new SolidBrush(topForegroundColor   );
                SolidBrush bottomBackgroundBrush = new SolidBrush(bottomBackgroundColor);
                SolidBrush bottomForegroundBrush = new SolidBrush(bottomForegroundColor);
 
                DrawSineSplitText
                (
                    e.Graphics,
                    "  ؽƮ",
                    font,
                    this.pictureBox.ClientRectangle,
                    topBackgroundBrush,
                    topForegroundBrush,
                    bottomBackgroundBrush,
                    bottomForegroundBrush,
                    2.5f,
                    0.25f
                );

                topBackgroundBrush.Dispose();
                topForegroundBrush.Dispose();
                bottomBackgroundBrush.Dispose();
                bottomForegroundBrush.Dispose();
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region  и ؽƮ ׸ - DrawSineSplitText(graphics, text, font, rectangle, topBackgroundBrush, topForegroundBrush, bottomBackgroundBrush, bottomForegroundBrush, waveCount, scaleY)

        /// <summary>
        ///  и ؽƮ ׸
        /// </summary>
        /// <param name="graphics">׷Ƚ</param>
        /// <param name="text">ؽƮ</param>
        /// <param name="font">Ʈ</param>
        /// <param name="rectangle">簢</param>
        /// <param name="topBackgroundBrush">  귯</param>
        /// <param name="topForegroundBrush">  귯</param>
        /// <param name="bottomBackgroundBrush">ϴ  귯</param>
        /// <param name="bottomForegroundBrush">ϴ  귯</param>
        /// <param name="waveCount">̺ </param>
        /// <param name="scaleY">Y </param>
        private void DrawSineSplitText
        (
            Graphics  graphics,
            string    text,
            Font      font,
            Rectangle rectangle,
            Brush     topBackgroundBrush,
            Brush     topForegroundBrush,
            Brush     bottomBackgroundBrush,
            Brush     bottomForegroundBrush,
            float     waveCount,
            float     scaleY
        )
        {
            Bitmap topBitmap    = new Bitmap(rectangle.Width, rectangle.Height);
            Bitmap bottomBitmap = new Bitmap(rectangle.Width, rectangle.Height);

            using(StringFormat stringFormat = new StringFormat())
            {
                stringFormat.Alignment     = StringAlignment.Center;
                stringFormat.LineAlignment = StringAlignment.Center;

                using(Graphics topGraphics = Graphics.FromImage(topBitmap))
                {
                    topGraphics.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;

                    topGraphics.FillRectangle(topBackgroundBrush, rectangle);

                    topGraphics.DrawString(text, font, topForegroundBrush, rectangle, stringFormat);
                }

                using(Graphics bottomGraphics = Graphics.FromImage(bottomBitmap))
                {
                    bottomGraphics.TextRenderingHint = TextRenderingHint.AntiAliasGridFit;

                    bottomGraphics.FillRectangle(bottomBackgroundBrush, rectangle);

                    bottomGraphics.DrawString(text, font, bottomForegroundBrush, rectangle, stringFormat);
                }
            }

            using(TextureBrush brush = new TextureBrush(topBitmap))
            {
                graphics.FillRectangle(brush, rectangle);
            }

            List<PointF> pointList = new List<PointF>();

            float magnitude = (font.Size * 96f / 72f) / 2 * scaleY;
            float offsetY   = rectangle.Height / 2f;

            pointList.Add(new PointF(0, rectangle.Height));

            float scaleX = (float)(waveCount * 2 * Math.PI / rectangle.Width);

            for(int x = 0; x < rectangle.Width; x++)
            {
                float y = (float)(offsetY + magnitude * Math.Sin(x * scaleX));

                pointList.Add(new PointF(x, y));            
            }

            pointList.Add(new PointF(rectangle.Width - 1, rectangle.Height));

            using(TextureBrush brush = new TextureBrush(bottomBitmap))
            {
                graphics.SmoothingMode = SmoothingMode.AntiAlias;

                graphics.FillPolygon(brush, pointList.ToArray());
            }

            topBitmap.Dispose();
            bottomBitmap.Dispose();
        }

        #endregion
    }
}